#include "PosHistory.hpp"
#include <SFML/Graphics/Vertex.hpp>
#include <SFML/System/Vector2.hpp>
#include <optional>

bool rounded_positions_equal(sf::Vector2f& a, sf::Vector2f& b) {
    if (int(a.x) != int(b.x)) return false;
    if (int(a.y) != int(b.y)) return false;
    return true;
}

void PosHistory::append(sf::Vector2f point) {
    if (!shouldInsert(point)) return;
    _points[_insertionIndex] = sf::Vertex(point);
    _insertionIndex += 1;
    if (_insertionIndex >= _capacity) _insertionIndex = 0; // note : loops over to start of the array.
    _lastInsertion = std::optional(point);
}

bool PosHistory::shouldInsert(sf::Vector2f& point) {
    if (!_lastInsertion.has_value()) return true;
    auto last = _lastInsertion.value();
    if (rounded_positions_equal(last, point)) return false;
    return true;
}
