#pragma once

#include <SFML/Graphics/PrimitiveType.hpp>
#include <SFML/Graphics/VertexArray.hpp>
#include <SFML/System/Vector2.hpp>
#include <cstddef>
#include <optional>

class PosHistory {
    sf::VertexArray _points;
    std::optional<sf::Vector2f> _lastInsertion;
    size_t _insertionIndex;
    size_t _capacity;
    public:
        inline PosHistory(size_t capacity) :
            _points(sf::VertexArray(sf::PrimitiveType::Points, capacity)),
            _lastInsertion(std::optional<sf::Vector2f>()),
            _insertionIndex(0),
            _capacity(capacity)
        {
            // for (size_t i = 0; i < capacity_; i += 1) append(sf::Vector2f(-1, -1));
        }
        void append(sf::Vector2f point);
        inline sf::VertexArray& vertices() { return _points; }
    private:
        bool shouldInsert(sf::Vector2f& point);
};
