#include <cmath>
#include "filter.hpp"

void MotorJitterFilter::set(float value) {
    _value = value;
}

float MotorJitterFilter::get(float delta) {
    update(delta);
    if (_stateIsOn) return 1;
    else return 0;
}

float MotorJitterFilter::delayOfState() {
    float result = 0;
    if (_stateIsOn) result = _delay * _value;
    else result = _delay * (1 - _value);
    return std::fmax(result, 0);
}

void MotorJitterFilter::update(float delta) {
    _delaySinceState += delta;
    if (_delaySinceState < delayOfState()) return;
    _stateIsOn = !_stateIsOn;
}
